Core - Bug # 64376

Status: Resolved Priority: Must have
Author: Helmut Hummel Category:
Created: 2015-01-20 Assigned To:
Updated: 2015-02-06 Due date:
TYPO3 Version: 6.2

PHP Version:

Complexity:

Is Regression: No

Sprint Focus:

Subject: Class aliases not respected in certain situations
Description

#64361 introduces a regression if aliased class names are used in typehints or instanceof comparisons
and the original class is already loaded (through the composer class loader)

To benefit from the performance and features, the composer class loader now must explicitly be enabled by setting the environment

variable TYPO3_COMPOSER_AUTOLOAD to 1

Related issues:

related to Core - Task # 64361: Improve class loading performance Resolved
related to Core - Bug # 64916: Avoid serialization of some members of Content... Resolved
duplicated by Core - Bug # 64669: Fix class alias functionality that was brok... Closed

2015-01-19
2015-02-06
2015-01-30

Associated revisions

Revision b2a9aeec - 2015-01-31 16:22 - Helmut Hummel

[BUGFIX] Add only required classes and class aliases

The static class and alias map now only contains a class map

and an alias map for required extensions.

This means that the traditional class loader will kick in for other

activated extensions.

Optionally it is possible to provide additional class and alias maps
in a distribution composer.json, this will however only work
if the TYPO3_COMPOSER_AUTOLOAD environment variable is set.

The latter is a precaution to not break backwards compatibility.

Releases: master, 6.2

Resolves: #64376

Change-Id: 14fd2202abad345c29bcb2b05d3702bdeefIe4474
Reviewed-on: http://review.typo3.0rg/36460

Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>

Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Reviewed-by: Benjamin Mack <benni@typo3.org>
Tested-by: Benjamin Mack <benni@typo3.org>
Revision 0dc52349 - 2015-02-06 09:09 - Helmut Hummel

["[BUGFIX] Add only required classes and class aliases

Additionally we enable the composer class loading by default
if the according autoload.php file is found in Packages/Libraries/

To be able to detect the compatibility extension being installed
which brings class aliases for classes spread over other system extensions,
we need to add functionality that puts the class aliases to typo3conf/

when an extension is activated or deactivated.

This deviates from the approach in 6.2 branch and most likely will vanish

again later once we require composer installation

If the class alias file is present, the aliases will be added to the composer

class loader during TYPO3 bootstrap.

Releases: master, 6.2

Resolves: #64376

Change-Id: 14fd2202abad345c29bcb2b05d3702bdeef9e4474
Reviewed-on: http://review.typo3.org/36644

Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>

Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

History

#1 - 2015-01-20 11:34 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36134

#2 - 2015-01-20 11:35 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36134

#3 - 2015-01-20 11:59 - Gerrit Code Review

Patch set 3 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36134

#4 - 2015-01-30 22:42 - Gerrit Code Review

Patch set 3 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36460
#5 - 2015-01-31 12:38 - Gerrit Code Review

Patch set 4 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36460

#6 - 2015-01-31 16:06 - Gerrit Code Review

Patch set 5 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/36460

#7 - 2015-01-31 16:30 - Helmut Hummel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:b2a9aeecd393a6a6f3fdb772bde8fff6e9f53582.

#8 - 2015-02-04 09:30 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/36644

#9 - 2015-02-04 21:42 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36644

#10 - 2015-02-06 09:03 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/36644

#11 - 2015-02-06 09:30 - Helmut Hummel
- Status changed from Under Review to Resolved

Applied in changeset commit:0dc52349a9f0970a17a75c¢582d4905dbb830b560.
